# coding=utf8

import tkinter
from tkinter import messagebox

# http://www.tutorialspoint.com/python/python_gui_programming.htm
# http://www.tutorialspoint.com/python/tk_text.htm

class MyApp(tkinter.Frame):

	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.pack(expand=True, fill="both")
		self.setGUI()

	def setGUI(self):	
		# pack ist wie das DockPanel in WPF
		# erst muessen die "normalen" UI-Elemente eintgetragen werden
		# am Schluss werden die UI-Elemente eingetragen, die fill="both" haben

		inputframe = tkinter.Frame(self)
		inputframe.config(background = "red") #"#FF0000"
		inputframe.pack(fill="x", side="top" )

		self.label1 = tkinter.Label(inputframe, fg="blue", bg="#FFFF00")
		self.label1["text"] = "Eingabe"
		self.label1.pack(side="left")
	
		self.inputui = tkinter.Entry(inputframe)
		self.inputui.pack(expand=True,fill="x",padx="5",pady="5")
		

		self.var_name = tkinter.StringVar()
		self.var_name.set("Ihr Name...")
		self.inputui["textvariable"] = self.var_name


		buttonframe = tkinter.Frame(self)
		buttonframe.config(background = "blue") #"#FF0000"
		buttonframe.pack(fill="x", side="bottom" )

		self.bnEsc = tkinter.Button(buttonframe)
		self.bnEsc["text"] = "Beenden"
		self.bnEsc["command"] = self.quit
		self.bnEsc.pack(padx="5", side="right")

		self.bnAction = tkinter.Button(buttonframe)
		self.bnAction["text"] = "Action"
		self.bnAction["command"] = self.onAction
		self.bnAction.pack(side="right")


		# nun ein Editor mit fill=both
		editorframe = tkinter.Frame(self)
		editorframe.pack(expand=True,fill="both", side="top" )

		sbx = tkinter.Scrollbar(editorframe, orient="horizontal")
		sbx.pack(fill="x", side="bottom")

		sby = tkinter.Scrollbar(editorframe)
		sby.pack(fill="y", side="right")

		self.editor = tkinter.Text(editorframe)
		self.editor.config(wrap="none")  # wrap="word"  word char 
		self.editor.pack(expand=True, fill="both", padx="5",pady="5")

		self.editor["xscrollcommand"] = sbx.set
		sbx["command"] = self.editor.xview
		self.editor["yscrollcommand"] = sby.set
		sby["command"] = self.editor.yview


	def onAction(self):
		str = self.var_name.get()
		#messagebox.showinfo( "Hello Python", str)
		self.editor.insert("end",str+"\r\n")



root = tkinter.Tk()
root.title("Doku_ui5.py")
root.geometry("300x400")
app = MyApp(root)
app.mainloop()


