# coding=utf8

import tkinter
from tkinter import messagebox

class MyApp(tkinter.Frame):

	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.pack(expand=True, fill="both")
		self.setGUI()

	def setGUI(self):
		# JPanel fuer ui-Elemente
		frameButton = tkinter.Frame(self)
		frameButton.pack(fill="x", side="bottom", pady="5")

		# JPanel fuer ui-Elemente
		frame1 = tkinter.Frame(self)
		frame1.pack(expand=True, fill="both", side="top", pady="5")

		sb = tkinter.Scrollbar(frame1)
		sb.pack(fill="y",side="right")

		self.listbox = tkinter.Listbox(frame1,selectmode="extended")
		self.listbox.pack(fill="both",expand=True)

		self.listbox["yscrollcommand"] = sb.set
		sb["command"]=self.listbox.yview

		for i in range(20+1):
			self.listbox.insert("end",str(i))

		self.listbox.insert(0, "abc")
		self.listbox.insert(0, "def")


		self.bnEsc = tkinter.Button(frameButton)
		self.bnEsc["text"] = "Ende"
		self.bnEsc["command"] = self.quit
		self.bnEsc.pack(side="right")

		self.bnAction = tkinter.Button(frameButton)
		self.bnAction["text"] = "Action"
		self.bnAction["command"] = self.actionClick
		self.bnAction.pack(side="right")
 

	def actionClick(self):
		items = self.listbox.curselection() # tuple !!!
		if len(items)==0:
			messagebox.askokcancel( "Meldung", "Bitte einen Eintrag auswählen") 
			return
		index = items[0] # Tuple (indizes)
		item = self.listbox.get(index)
		messagebox.askokcancel( "1. selektierter Eintrag", item)

		indizes = self.listbox.curselection()
		for i in indizes:
			messagebox.askokcancel( "Selektierter Eintrag", str(i))


root = tkinter.Tk()
root.title("Listbox")
root.geometry("250x200")
app = MyApp(root)
app.mainloop()

