# coding=utf8

import tkinter
from tkinter import messagebox

# http://www.tutorialspoint.com/python/tk_spinbox.htm

# Dialog with a spinbox
# Spinbox is a list-spinbox with the values (tuples)

class MyApp(tkinter.Frame):

	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.pack(expand=True, fill="both")
		self.setGUI()

	def setGUI(self):
		inputframe = tkinter.Frame(self)
		inputframe.background = "red" #"#FF0000"
		inputframe.pack(expand=True,fill="x", side="top" )

		self.label1 = tkinter.Label(inputframe)
		self.label1["text"] = "Eingabe"
		self.label1.bd = 10  # border width
		self.label1.fg = "blue" #"#FF0000"  # foreground
		self.label1.bg = "#FF0000"   # backcolor
		self.label1.pack(side="left")
	
		self.spinbox = tkinter.Spinbox(inputframe)
		self.spinbox.activebackground = "blue"
		self.spinbox.pack(expand=True,fill="x",padx="5",pady="5")
		self.spinbox.config(values = ("AI","VW","W"))
		
		self.var_spinbox = tkinter.StringVar()
		self.var_spinbox.set("AI")
		self.spinbox["textvariable"] = self.var_spinbox

		buttonframe = tkinter.Frame(self)
		buttonframe.pack(expand=True,fill="x", side="top" )

		self.bnEsc = tkinter.Button(buttonframe)
		self.bnEsc["text"] = "Ende"
		self.bnEsc["command"] = self.quit
		self.bnEsc.pack(side="right",padx="5")

		self.bnAction = tkinter.Button(buttonframe)
		self.bnAction["text"] = "Action"
		self.bnAction["command"] = self.onAction
		self.bnAction.pack(side="right",padx="5")

	def onAction(self):
		strValue = self.var_spinbox.get()
		messagebox.showinfo( "Hello Python", strValue)




root = tkinter.Tk()
root.title("Spinbox 3")
root.geometry("250x100")
app = MyApp(root)
app.mainloop()
