unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Buttons, ExtCtrls, ComCtrls, StdCtrls;

type
  TFMain = class(TForm)
    Panel1: TPanel;
    BnDateiOeffnen: TSpeedButton;
    BnSaveFile: TSpeedButton;
    BnNeu: TSpeedButton;
    BnUndo: TSpeedButton;
    BnCut: TSpeedButton;
    BnCopy: TSpeedButton;
    BnPaste: TSpeedButton;
    BnCompile: TSpeedButton;
    BnRun: TSpeedButton;
    PanelExpand: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    MainMenu1: TMainMenu;
    MainDatei: TMenuItem;
    MnNeu: TMenuItem;
    MnOeffnen: TMenuItem;
    N1: TMenuItem;
    MnTaschenrechner: TMenuItem;
    MnDOSEbene: TMenuItem;
    MnExplorer: TMenuItem;
    MnNotepad: TMenuItem;
    N3: TMenuItem;
    MnExit: TMenuItem;
    MnStrichAlteDateien: TMenuItem;
    MnAlteDatei1: TMenuItem;
    MnAlteDatei2: TMenuItem;
    MnAlteDatei3: TMenuItem;
    MnAlteDatei4: TMenuItem;
    MnAlteDatei5: TMenuItem;
    MnAlteDatei6: TMenuItem;
    MnAlteDatei7: TMenuItem;
    MnAlteDatei8: TMenuItem;
    MnAlteDatei9: TMenuItem;
    MainOptionen: TMenuItem;
    MnEinstellungen: TMenuItem;
    MainFenster: TMenuItem;
    MnVorherigesFenster: TMenuItem;
    MnNaechstesFenster: TMenuItem;
    N4: TMenuItem;
    MnFensterTeilen: TMenuItem;
    MnFensterVertikalteilen: TMenuItem;
    MnFensterKaskade: TMenuItem;
    MnAlleSymboleanordnen: TMenuItem;
    MainHilfe: TMenuItem;
    MnProduktInfo: TMenuItem;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    MainMemo: TRichEdit;
    LabelEditorFont: TLabel;
    LabelErrorFont: TLabel;
    Timer1: TTimer;
    procedure MnNeuClick(Sender: TObject);
    procedure MnOeffnenClick(Sender: TObject);
    procedure MnTaschenrechnerClick(Sender: TObject);
    procedure MnDOSEbeneClick(Sender: TObject);
    procedure MnExplorerClick(Sender: TObject);
    procedure MnNotepadClick(Sender: TObject);
    procedure MnExitClick(Sender: TObject);
    procedure MnEinstellungenClick(Sender: TObject);
    procedure MnVorherigesFensterClick(Sender: TObject);
    procedure MnNaechstesFensterClick(Sender: TObject);
    procedure MnFensterTeilenClick(Sender: TObject);
    procedure MnFensterVertikalteilenClick(Sender: TObject);
    procedure MnFensterKaskadeClick(Sender: TObject);
    procedure MnAlleSymboleanordnenClick(Sender: TObject);
    procedure MnProduktInfoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BnUndoClick(Sender: TObject);
    procedure BnCutClick(Sender: TObject);
    procedure BnCopyClick(Sender: TObject);
    procedure BnPasteClick(Sender: TObject);
    procedure BnCompileClick(Sender: TObject);
    procedure BnRunClick(Sender: TObject);
    procedure BnSaveFileClick(Sender: TObject);
  private
    { Private-Deklarationen }
    _EditorPfad:string;
    _StartenFertig:boolean;

    _Filter:string;
    _Filtermaske:string;
    _Ext:string;

    _Fenster:TList;
    _ClientDatei:string;  // Bei Aktivierung eines Client-Fensters gesetzt
    
    procedure OeffneDatei(filename:string);
    procedure EditorDateiladen(filename:string);
  public
    { Public-Deklarationen }
    procedure LoescheFensterEintrag(handle:THandle);
    procedure setzeFensterHandle(Handle:THandle; filename:string; bChange:boolean);
    procedure SpeichernAlleMDIFenster;
    procedure AlleFensterSchliessen;
  end;

var
  FMain: TFMain;

implementation

{$R *.dfm}


uses math, Fbasis, basis, shellapi,  MDIDEdit, PythonIDE_bas, PythonIDE_var, Einst, start;
//, DDoc;


procedure TFMain.FormCreate(Sender: TObject);
begin
  _Fenster:=TList.create;  // Speichert die Adressen
  G_EditorPfad := G_Pfad;
  _EditorPfad := G_Pfad;

  _Filter:= 'Python-Dateien (*.py)|Alle Dateien (*.*)|*.*';
  _Filtermaske := '*.Py';

  Application.HelpFile := G_Pfad + 'EDIT32.HLP';

  // Application.OnHint := ShowHint;
  G_CONFIGFILE := G_Pfad+'EDIT32.INI';

  leseKonfiguration;

  LabelEditorFont.Font.Name := G_EditorSchriftName;
  LabelEditorFont.Font.Size := G_EditorSchriftGroesse;
  if G_EditorSchriftBold
  then LabelEditorFont.Font.Style := [fsBold]
  else LabelEditorFont.Font.Style := [];
  LabelEditorFont.Font.Color := G_EditorSchriftFarbe;

  LabelErrorFont.Font.Name := G_ErrorSchriftName;
  LabelErrorFont.Font.Size := G_ErrorSchriftGroesse;
  if G_ErrorSchriftBold
  then LabelErrorFont.Font.Style := [fsBold]
  else LabelErrorFont.Font.Style := [];
  LabelErrorFont.Font.Color := G_ErrorSchriftFarbe;


  StatusBar1.Panels.Items[0].Text  := ' ';
  StatusBar1.Panels.Items[1].Text  := ' ';
  StatusBar1.Panels.Items[2].Text  := '';
  StatusBar1.Panels.Items[3].Text  := '';

  G_Handle := 0;

  _StartenFertig :=false;


  _StartenFertig:=true;
  if Paramcount>0 then Timer1.enabled := true;
end;


procedure TFMain.MnNeuClick(Sender: TObject);
begin
  EditorDateiladen('');
end;

procedure TFMain.MnOeffnenClick(Sender: TObject);
var szAktPfad:String;
    i:integer;
begin
  getDir(0,szAktPfad);

  OpenDialog1.Title := 'Datei ffnen';

  OpenDialog1.DefaultExt := '.py';
  OpenDialog1.FileName:= '*.py';
  OpenDialog1.Filter := 'Python (*.py)|*.py|Alle Dateien (*.*)|*.*';
  OpenDialog1.InitialDir := _EditorPfad;

  OpenDialog1.Options :=  [ofEnableSizing, ofAllowMultiSelect, ofPathMustExist,ofShowHelp];

  if OpenDialog1.Execute then
  begin
    with OpenDialog1.Files do
    begin
      // FileListebox.Items := OpenDialog1.Files;
      for I:=Count-1 downto 0 do
      begin
        OeffneDatei(Strings[i]);
      end;
    end;
    // Meldung('ready','');
  end;
  chDir(szAktPfad);
  OpenDialog1.Options :=  [ofEnableSizing, ofShowHelp];
end;

procedure TFMain.OeffneDatei(filename:string);
var szZ, szPfad, szName, szExt:String;
    i:integer;
    pF:TFMDIDEdit;
begin
  if not FileExists(filename) then
  begin
    Meldung('Datei ffnen','Die Datei'+NL+ filename+NL+'existiert nicht');
    exit;
  end;
  fsplit(filename,szPfad, szName,szExt);
  _StartenFertig:=false;

  LoescheAlteDateiEintrag(filename);

  _StartenFertig:=true;

  szZ := AnsiUppercase(filename);
  for i:=1 to _Fenster.Count do
  begin
    pF := _Fenster.Items[i-1];
    if AnsiUppercase(pF.getFileName) = szZ then
    begin
      Meldung('Hinweis','Datei ist schon geladen'+NL+filename);
      exit;
    end;
  end;
  EditorDateiladen( filename );
end;  // OeffneDatei


procedure TFMain.MnTaschenrechnerClick(Sender: TObject);
begin
  if ExecuteFile('Calc.exe', '', '', SW_SHOW)<=32 then
  begin
    Fehler('Fehler','Fehler beim Aufruf des Taschenrechners');
  end;
end;

procedure TFMain.MnDOSEbeneClick(Sender: TObject);
var sVerz, szZ:string;
    pF:TFMDIDEdit;
begin
  if G_DosProgrammComSpec
  then szZ := getComspec
  else szZ := G_szDosProgramm;

  if _Fenster.Count=0 then
  begin
     sVerz := G_Pfad;
  end
  else
  begin
    pF := _Fenster.Items[0];
    if pF.WindowState <> wsMinimized then
    begin
      sVerz := pF.getPath();
      if sVerz='' then sVerz := G_Pfad;
    end
    else
    begin
      sVerz := G_Pfad;
    end;
  end;

  if  ShellExecute(Application.MainForm.Handle, nil,
      PChar(szZ), PChar(''), PChar(sVerz), SW_SHOW) <= 32 then
  begin
    Meldung('Fehler', 'Fehler: '+IntToStr(handle));
  end;
end;

procedure TFMain.MnExplorerClick(Sender: TObject);
begin
 if ExecuteFile('Explorer.exe', '', '', SW_SHOW)<=32 then
  begin
    Fehler('Fehler','Fehler beim Aufruf des Explorers');
  end;
end;

procedure TFMain.MnNotepadClick(Sender: TObject);
begin
  if ExecuteFile('Notepad.exe', '', '', SW_SHOW)<=32 then
  begin
    Fehler('Fehler','Fehler beim Aufruf des Notepads');
  end;
end;

procedure TFMain.MnExitClick(Sender: TObject);
begin
  Close();
end;

procedure TFMain.MnEinstellungenClick(Sender: TObject);
begin
//
end;

procedure TFMain.MnVorherigesFensterClick(Sender: TObject);
begin
  previous;
end;

procedure TFMain.MnNaechstesFensterClick(Sender: TObject);
begin
  next;
end;

procedure TFMain.MnFensterTeilenClick(Sender: TObject);
begin
  tile;
end;

procedure TFMain.MnFensterVertikalteilenClick(Sender: TObject);
var Hoffset, HStbar, HError, h0, wi, w0, w, n, i:integer;
    pF:TFMDIDEdit;
begin
  Tile;

  n := 0;
  for i:=1 to _Fenster.Count do
  begin
    pF := _Fenster.Items[i-1];
    if pF.WindowState <> wsMinimized then inc(n,1);
  end;
  if n = 0 then exit;

  if Panel1.Visible
  then h0 := Panel1.Height+1
  else h0 := 0;

  if StatusBar1.Visible
  then HStbar:=StatusBar1.Height
  else HStbar := 0;


  if (H0=0) and (HStBar=0)
  then HOffset := 6
  else HOffset := 10;

  w  := (Clientwidth-n-n) div n;
  w0 := (Clientwidth-n-n) mod n;

  wi:= 0;
  for i:=1 to _Fenster.Count do
  begin
    pF := _Fenster.Items[i-1];
    if pF.WindowState <> wsMinimized then
    begin
        pF.left := wi;
        pF.Top := h0;
        pF.Top := 0;
        pF.Height := Clientheight - (h0+HStbar) - Hoffset-HError;
        if i = 1 then
        begin
          pF.width := w+w0;
          wi := wi + w + w0;
        end
        else
        begin
          pF.width := w;
          wi := wi + w;
        end;
    end;
  end;  // for
end;

procedure TFMain.MnFensterKaskadeClick(Sender: TObject);
begin
  cascade;
end;

procedure TFMain.MnAlleSymboleanordnenClick(Sender: TObject);
begin
    ArrangeIcons;
end;

procedure TFMain.MnProduktInfoClick(Sender: TObject);
begin
//
end;

procedure TFMain.LoescheFensterEintrag(handle:THandle);
var i:integer;
    pF:TFMDIDEdit;
begin
  for i:=1 to _Fenster.Count do
  begin
    pF := _Fenster.Items[i-1];
    if pF.handle = handle then
    begin
      EinfuegenAlteDateiEintrag( pF.getFileName );
      StatusBar1.Panels.Items[1].Text  := '';
      _Fenster.Delete(i-1);
      break;
    end;
  end;
end;  // LoescheFensterEintrag

procedure TFMain.setzeFensterHandle(Handle:THandle; filename:string; bChange:boolean);
var i:integer;
    pF:TFMDIDEdit;
begin
  G_handle:= Handle;
  _ClientDatei := filename;
  if bChange
  then StatusBar1.Panels.Items[1].Text  := 'gendert'
  else StatusBar1.Panels.Items[1].Text  := '';

  if _Fenster<> nil then
  begin
    for i:=1 to _Fenster.Count do
    begin
      pF := _Fenster.Items[i-1];
      // pF.close;
    end;
  end;
end;

procedure TFMain.SpeichernAlleMDIFenster;
var i:integer;
    pF:TFMDIDEdit;
begin
  for i:=1 to _Fenster.Count do
  begin
    pF := _Fenster.Items[i-1];
    pF.MnSpeichernClick(self);
  end;
end;

procedure TFMain.AlleFensterSchliessen;
var i:integer;
    pF:TFMDIDEdit;
begin
  for i:=1 to _Fenster.Count do
  begin
    pF := _Fenster.Items[i-1];
    pF.close;
  end;
end;  // Close All

procedure TFMain.EditorDateiladen(filename:string);
var szPfad, szName, szExt:String;
var f:TFMDIDEdit;
begin
  fsplit(filename, szPfad, szName, szExt);
  _Ext := szExt;
  if length(filename)>0 then
  begin
    G_EditorPfad := szPfad;
    Write_IniString(G_CONFIGFILE,'Pfade','EditorPfad',G_EditorPfad);
    speichereKonfiguration;  // ????
  end;


  f:=TFMDIDEdit.Create(Application);
  try
    _Fenster.add(f);
    f.Init(filename);
  finally
  end;
end;  //  MnEditorDateiladen



procedure TFMain.Timer1Timer(Sender: TObject);
var i:integer;
begin
  Timer1.enabled := false;
  for i:=1 to Paramcount do
  begin
    if FileExists(ParamStr(i)) then
    begin
      OeffneDatei( ParamStr(i) );
    end;
  end;
end;

procedure TFMain.BnUndoClick(Sender: TObject);
begin
  sendmessage(G_handle,WM_MYUndo,111,111);

end;

procedure TFMain.BnCutClick(Sender: TObject);
begin
  sendmessage(G_handle,WM_MYCut,111,111);
end;

procedure TFMain.BnCopyClick(Sender: TObject);
begin
  sendmessage(G_handle,WM_MYCopy,111,111);
end;

procedure TFMain.BnPasteClick(Sender: TObject);
begin
  sendmessage(G_handle,WM_MYPaste,111,111);   // unit basis
end;

procedure TFMain.BnCompileClick(Sender: TObject);
begin
//
end;

procedure TFMain.BnRunClick(Sender: TObject);
begin
//
end;

procedure TFMain.BnSaveFileClick(Sender: TObject);
begin
  sendmessage(G_handle,WM_MYSave,111,111);
end;

end.
